<template>
  <el-select
    v-model="value"
    multiple
    filterable
    remote
    clearable
    collapse-tags
    :multiple-limit="1"
    reserve-keyword
    :size="size || 'medium'"
    style="width: 100%"
    :placeholder="placeholder || ''"
    :disabled="disabled"
    :remote-method="remoteMethod"
    :loading="selectLoading"
    @change="selectChange"
  >
    <el-option
      v-for="(item, index) in options"
      :key="item.id + index"
      :label="item.search"
      :value="item.id + ''"
      :disabled="item.status !== '1'"
    >
    </el-option>
  </el-select>
</template>

<script>
import asyncRequest from "@/apis/components/search-sort";
import resToken from "@/mixins/resToken";
export default {
  name: "SearchSort",
  mixins: [resToken],
  props: [
    "size",
    "value",
    "placeholder",
    "isDetail",
    "disabled",
    "names",
    "type",
  ],
  /**
   * 属性集合
   * @param {String}        size             : 组件大小            非必填
   * @param {Array}         value            : 选中值              必填
   * @param {String}        placeholder      : 提示信息            非必填
   * @param {Boolean}       isDetail          : 是否是详情逻辑       必填
   * @param {Boolean}       disabled         : 是否禁用            必填
   * @param {String}        names            : 选中值label         展示详情必填
   * @param {String}        type             : 数据类型            非必填 1是平台供应商0非平台供应商
   */
  /**
   * 事件集合
   * @searchChange             : 选中值变化调用   抛出选中数据
   */
  data() {
    return {
      options: [],
      selectLoading: false,
      searchName: "",
    };
  },
  watch: {
    names: function (val, old) {
      // console.log(val, old, this.isDetail, "1");
      this.searchName = val;
      if (this.isDetail && this.searchName) {
        this.remoteMethod(this.searchName);
      }
    },
    isDetail: function (val, old) {
      // console.log(val, old, this.isDetail, "2");
      if (val && this.searchName) {
        this.remoteMethod(this.searchName);
      }
    },
  },
  mounted() {
    this.options = [];
    this.selectLoading = false;
  },
  methods: {
    async selectChange(e) {
      if (e && e.length > 0) {
        let index = this.options.findIndex((v) => v.id === e[0]);
        if (index !== -1) {
          let model = {
            pid: this.options[index].item[0],
            id: this.options[index].id,
            code: this.options[index].id,
            label: this.options[index].search,
            cat_desc: this.options[index].cat_desc,
            item:this.options[index].item,
          };
          this.$emit("searchChange", model);
        } else {
          this.$emit("searchChange", {});
        }
      } else {
        this.$emit("searchChange", {});
      }
    },
    async remoteMethod(query) {
      this.selectLoading = true;
      if (query !== "") {
        this.options = [];
        let formValue = {
          page: 1,
          size: 100,
          search: query,
          cat_name: "",
          pid: "",
          status: "",
        };
        let res = await asyncRequest.list(formValue);
        if (res && res.code === 0 && res.data) {
          const { list } = res.data;
          this.options = list;
        } else if (res && res.code >= 100 && res.code <= 104) {
          await this.logout();
        } else {
          this.$message.warning(res.message);
        }
      } else {
        this.options = [];
      }
      this.selectLoading = false;
    },
  },
};
</script>

<style>
</style>